package yhq.jad.easydemo;

import java.util.List;  

import android.content.Context;  
import android.net.DhcpInfo;
import android.net.wifi.ScanResult;  
import android.net.wifi.WifiConfiguration;  
import android.net.wifi.WifiInfo;  
import android.net.wifi.WifiManager;  
import android.net.wifi.WifiManager.WifiLock;  

public class WLANAPI
{
	//һWifiManager  
    WifiManager mWifiManager;  
    //һWifiInfo  
    private WifiInfo mWifiInfo;     
    //һDhcpInfo  
    DhcpInfo mDhcpInfo; 
    //ɨб  
    private List<ScanResult> mWifiList;  
    //б  
    private List<WifiConfiguration> mWifiConfigurations;  
    WifiLock mWifiLock;  
    public WLANAPI(Context context)
    {  
        //ȡWifiManager  
        mWifiManager=(WifiManager) context.getSystemService(Context.WIFI_SERVICE);  
        //ȡWifiInfo  
        mWifiInfo=mWifiManager.getConnectionInfo();  
        //ȡDhcpInfo  
        mDhcpInfo = mWifiManager.getDhcpInfo(); 
    } 
    
    //鵱ǰwifiǷ   
    public boolean Wifi_Is_Open() 
    {    
    	boolean state=false;
    	if(!mWifiManager.isWifiEnabled())
        {  
    		state=false;  
        } 
    	else
    	{
    		state=true;
		}
    	return state; 
    }
    
    //wifi  
    public void openWifi()
    {  
        if(!mWifiManager.isWifiEnabled())
        {  
            mWifiManager.setWifiEnabled(true);  
        }  
    }  
    //رwifi  
    public void closeWifi()
    {  
        if(!mWifiManager.isWifiEnabled())
        {  
            mWifiManager.setWifiEnabled(false);  
        }  
    }  
    //鵱ǰwifi״̬    
    public int checkState() 
    {    
        return mWifiManager.getWifiState();    
    }    
    //wifiLock  
    public void acquireWifiLock()
    {  
        mWifiLock.acquire();  
    }  
    //wifiLock  
    public void releaseWifiLock()
    {  
        //жǷ  
        if(mWifiLock.isHeld()){  
            mWifiLock.acquire();  
        }  
    }  
    //һwifiLock  
    public void createWifiLock()
    {  
        mWifiLock=mWifiManager.createWifiLock("test");  
    }  
    //õúõ  
    public List<WifiConfiguration> getConfiguration()
    {  
        return mWifiConfigurations;  
    }  
    //ָúõ  
    public void connetionConfiguration(int index)
    {  
        if(index>mWifiConfigurations.size())
        {  
            return ;  
        }  
        //úָID  
        mWifiManager.enableNetwork(mWifiConfigurations.get(index).networkId, true);  
    }  
    public void startScan()
    {  
        mWifiManager.startScan();  
        //õɨ  
        mWifiList=mWifiManager.getScanResults();  
        //õúõ  
        mWifiConfigurations=mWifiManager.getConfiguredNetworks();  
    }  
    //õб  
    public List<ScanResult> getWifiList()
    {  
        return mWifiList;  
    }  
    //鿴ɨ  
    public StringBuffer lookUpScan()
    {  
        StringBuffer sb=new StringBuffer();  
        for(int i=0;i<mWifiList.size();i++){  
            sb.append("Index_" + new Integer(i + 1).toString() + ":");  
             // ScanResultϢתһַ    
            // аѰBSSIDSSIDcapabilitiesfrequencylevel    
            sb.append((mWifiList.get(i)).toString()).append("\n");  
        }  
        return sb;    
    } 
    public String getMacAddress()
    {  
        return (mWifiInfo==null)?"NULL":mWifiInfo.getMacAddress();  
    } 
    public String getSSID()
    {  
        return (mWifiInfo==null)?"NULL":mWifiInfo.getSSID();  
    }
    public String getBSSID()
    {  
        return (mWifiInfo==null)?"NULL":mWifiInfo.getBSSID();  
    }  
    public int getIpAddress()
    {  
        return (mWifiInfo==null)?0:mWifiInfo.getIpAddress();  
    } 
    public int getGateway()
    {  
        return (mDhcpInfo==null)?0:mDhcpInfo.gateway;  
    }
    public int getMask()
    {  
        return (mDhcpInfo==null)?0:mDhcpInfo.netmask;  
    }
    //õӵID  
    public int getNetWordId()
    {  
        return (mWifiInfo==null)?0:mWifiInfo.getNetworkId();  
    }  
    //õwifiInfoϢ  
    public String getWifiInfo()
    {  
        return (mWifiInfo==null)?"NULL":mWifiInfo.toString();  
    }  
    //һ粢  
    public void addNetWork(WifiConfiguration configuration)
    {  
        int wcgId=mWifiManager.addNetwork(configuration);  
        mWifiManager.enableNetwork(wcgId, true);  
    }  
    //ϿָID  
    public void disConnectionWifi(int netId)
    {  
        mWifiManager.disableNetwork(netId);  
        mWifiManager.disconnect();  
    }  
    //Ҫӵ
    public WifiConfiguration CreateWifiInfo(String SSID, String Password, int Type)  
    {  
          WifiConfiguration config = new WifiConfiguration();    
           config.allowedAuthAlgorithms.clear();  
           config.allowedGroupCiphers.clear();  
           config.allowedKeyManagement.clear();  
           config.allowedPairwiseCiphers.clear();  
           config.allowedProtocols.clear();  
          config.SSID = "\"" + SSID + "\"";    
           
        WifiConfiguration tempConfig = this.IsExsits(SSID);            
          if(tempConfig != null) 
          {   
              mWifiManager.removeNetwork(tempConfig.networkId);   
          } 
         
          if(Type == 1) //WIFICIPHER_NOPASS 
          {  
               config.wepKeys[0] = "";  
               config.allowedKeyManagement.set(WifiConfiguration.KeyMgmt.NONE);  
               config.wepTxKeyIndex = 0;  
          }  
          if(Type == 2) //WIFICIPHER_WEP 
          {  
              config.hiddenSSID = true; 
              config.wepKeys[0]= "\""+Password+"\"";  
              config.allowedAuthAlgorithms.set(WifiConfiguration.AuthAlgorithm.SHARED);  
              config.allowedGroupCiphers.set(WifiConfiguration.GroupCipher.CCMP);  
              config.allowedGroupCiphers.set(WifiConfiguration.GroupCipher.TKIP);  
              config.allowedGroupCiphers.set(WifiConfiguration.GroupCipher.WEP40);  
              config.allowedGroupCiphers.set(WifiConfiguration.GroupCipher.WEP104);  
              config.allowedKeyManagement.set(WifiConfiguration.KeyMgmt.NONE);  
              config.wepTxKeyIndex = 0;  
          }  
          if(Type == 3) //WIFICIPHER_WPA 
          {  
          config.preSharedKey = "\""+Password+"\"";  
          config.hiddenSSID = true;    
          config.allowedAuthAlgorithms.set(WifiConfiguration.AuthAlgorithm.OPEN);    
          config.allowedGroupCiphers.set(WifiConfiguration.GroupCipher.TKIP);                          
          config.allowedKeyManagement.set(WifiConfiguration.KeyMgmt.WPA_PSK);                          
          config.allowedPairwiseCiphers.set(WifiConfiguration.PairwiseCipher.TKIP);                     
          //config.allowedProtocols.set(WifiConfiguration.Protocol.WPA);   
          config.allowedGroupCiphers.set(WifiConfiguration.GroupCipher.CCMP); 
          config.allowedPairwiseCiphers.set(WifiConfiguration.PairwiseCipher.CCMP); 
          config.status = WifiConfiguration.Status.ENABLED;    
          } 
           return config;  
    }
    //жĳǷ
    private WifiConfiguration IsExsits(String SSID)   
    {   
        List<WifiConfiguration> existingConfigs = mWifiManager.getConfiguredNetworks();   
           for (WifiConfiguration existingConfig : existingConfigs)    
           {   
             if (existingConfig.SSID.equals("\""+SSID+"\""))   
             {   
                 return existingConfig;   
             }   
           }   
        return null;    
    } 

}

